def insertion_step(L, i):
    """Esegue il passi i-esimo di insertion sort
    
    Assume che L[0], L[1], ... L[i-1] siano ordinati e che i>0
    """
    x   = L[i]    # salvo il valore da inserire
    pos = i       # posizione di inserimento
    while pos > 0 and L[pos-1] > x:
        print("Passo {}     i={}, pos={}".format(i-pos,i,pos),L)
        L[pos] = L[pos-1]   #sposto a destra L[pos-1]
        pos = pos -1
        
    print("Passo {}     i={}, pos={}".format(i-pos,i,pos),L)
    L[pos] = x
    print("Inserimento i={}, pos={}".format(i,pos),L)

def insertion_sort(L):
    """Ordina la sequenza seq utilizzando insertion sort"""
    print("Inizio   : {}".format(L))
    for i in range(1,len(L)):
        x = L[i]
        pos = i
        while pos > 0 and L[pos-1] > x:
            L[pos] = L[pos-1]   #sposto a destra L[pos-1]
            pos = pos -1
        L[pos] = x
        print("Passo i={}: {}".format(i,L))
